import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;

public class Server {

    public static void main(String[] args)
    {
        ServerSocket serverSocket = null;
        boolean listening = true;
	Vector playerList= new Vector();
	int nbDead=0;
        int nbPlayer = Integer.valueOf(args[0]).intValue();

        try {
            serverSocket = new ServerSocket(4444);
        } catch (IOException e) {
            System.err.println("Could not listen on port: 4444.");
            System.exit(-1);
        }

        System.out.println("socket ouverte\n");
        Synchronizer sync = new Synchronizer(nbPlayer);
        int rand = (int)(Math.random()*10 +1);
        try
	{
	for(int i=0;i<nbPlayer;i++)
	{
	    ServerThread temp = new ServerThread(serverSocket.accept(),i,sync,rand);
	    temp.start();
            playerList.add(temp);
            sync.put();
	}

        System.out.println("all is ok");

        try
	{
           Thread.sleep(500);
	}
        catch(InterruptedException e){}

        while (nbDead < nbPlayer)
	{
	    nbDead = 0;
	    for(int i=0;i<nbPlayer;i++) 
            {
		if (((Thread)playerList.get(i)).isAlive()) 
                {
		    sync.setTurn(i);
		}
		else 
		{
		    nbDead +=1;
		}
	    }
	}

        serverSocket.close();
	}
	catch (IOException e) {}

    }
}
