import java.net.*;
import java.io.*;

public class ServerThread extends Thread {
    private Socket socket = null;
    private int Id;
    private Synchronizer sync;
    private int rand=-1;

    public ServerThread(Socket socket, int Id, Synchronizer sync, int rand) {
        super("ServerThread");
        this.socket = socket;
        this.Id = Id;
        this.sync = sync;
	this.rand = rand;
    }

    public void run() {

        try {
	    InputStream toto = socket.getInputStream();
            PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
            BufferedReader in = new BufferedReader(
                                    new InputStreamReader(
                                    toto));

            String inputLine, outputLine;

            sync.get();

	    System.out.println("numero :"+rand);
            out.println("en avant ");
            out.flush();
	    
	    boolean fin=true;
	    while (fin)
	    {
		sync.waitmyTurn(Id);
		out.println("A ton tour de jouer : ");
		out.flush();
		inputLine = in.readLine();
		if (rand == Integer.valueOf(inputLine).intValue()) fin = false;
		sync.endmyTurn();
	    }
	       
            out.close();
            in.close();
            socket.close();

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

