import java.io.*;
import java.lang.*;

public class Synchronizer
{
    private int jetons;
    private int nb = 0;
    private boolean sync = true;
    private int turn = -1;

    public Synchronizer (int jetons)
    {
	this.jetons = jetons;
    }

    public synchronized void put()
    {
        nb +=1;
	if (nb == jetons)
	{
	   sync = false;
           notifyAll();
	}
    }

    public synchronized void get()
    {
	while (sync == true)
        {
	   try
	   {
	       wait();
	   }
	   catch(InterruptedException e){}
	}
    }

    public synchronized void setTurn(int turn)
    {
	while (sync == true)
        {
	   try
	   {
	       wait();
	   }
	   catch(InterruptedException e){}
	}
	
	this.turn = turn;
	System.out.println("cest a "+this.turn+" de jouer");
	sync = true;
        notifyAll();
    }

    public synchronized void waitmyTurn(int myId)
    {
	while ((myId != turn) || (sync == false))
	{
	   try
	   {
	       wait();
	   }
	   catch(InterruptedException e){}
	}
//	sync = true;
    }

    public synchronized void endmyTurn()
    {
        sync = false;
        notifyAll();
    }
}
       


